/*****************************************************

RX  nRF24L01+       !!!!!


This program was produced by the
CodeWizardAVR V2.05.3 Professional
Automatic Program Generator
 Copyright 1998-2011 Pavel Haiduc, HP InfoTech s.r.l.
http://www.hpinfotech.com

Project : 
Version : 
Date    : 22.07.2012
Author  : 
Company : 
Comments: 


Chip type               : ATmega8
Program type            : Application
AVR Core Clock frequency: 8,000000 MHz
Memory model            : Small
External RAM size       : 0
Data Stack size         : 256




Atmega8
          ------------------------------
       1-|PC6(Reset)       (ADC5/SCL)PC5|-28
       2-|PD0(RXD)         (ADC4/SDA)PC4|-27
       3-|PD1(TXD)             (ADC3)PC3|-26
       4-|PD2(INT0)            (ADC2)PC2|-25
       5-|PD3(INT1)            (ADC1)PC1|-24
       6-|PD4(XCK/T0)          (ADC0)PC0|-23
       7-|VCC                        GND|-22
       8-|GND                       AREF|-21
       9-|PB6(XTAL1/TOSC1)          AVCC|-20
      10-|PB7(XTAL2/TOSC2)      (SCK)PB5|-19
      11-|PD5(T1)              (MISO)PB4|-18
      12-|PD6(AIN0)        (MOSI/OC2)PB3|-17
      13-|PD7(AIN1)         (SS/OC1B)PB2|-16
      14-|PB0(ICP1)            (OC1A)PB1|-15
          ------------------------------ 


 Nokia 1100  -  D0-D3
     1100.h
 PD0 -  rst
 PD1 -  cs    
 PD2 -  sda
 PD3 -  sclk 
 
 
 nRF24L01+
 

 nRF     Mega
 MOSI---MOSI
 MISO---MISO
  SCK---SCK
CSN     PORTB.1
CE      PORTB.2
IRQ     PORTB.0


*****************************************************/

#include <mega8.h>
#include <delay.h>
#include "1100.h"
#include <stdio.h>

#define   CSN   PORTB.1
#define   CE    PORTB.2
#define   IRQ   PINB.0
//#define   F1    2        // 2 channel
#define   Data_0    33   //    
#define   Data_1    45



//unsigned int X, Y;
//unsigned int X1, Y1;

unsigned char tmp[12];
//unsigned char X_H, X_L, Y_H, Y_L;
unsigned char i, k, l, status ;
unsigned char St, d1, d2, d3, d4, d5;
unsigned char data[32];
unsigned char channel;
unsigned char RX_OK,  RX_OK1;
unsigned char F, F1, F2, F3, F4;  //   
unsigned char count_F, RX_Fail;
unsigned char timer, timer1 ;  // 20 ms  1s

unsigned int Kanal[7], K_H, K_L ;   //   

unsigned int n;

void SET_RF_Channel(unsigned char a);


// Timer1 overflow interrupt service routine
interrupt [TIM1_OVF] void timer1_ovf_isr(void)
{
// Place your code here
/*    
    //   
    
    if ( F==F1 )  F=F2;
    if ( F==F2 )  F=F3;    
    if ( F==F3 )  F=F4;
    if ( F==F4 )  { F=F1; count_F++;   } 
    SET_RF_Channel(F);
    if ( count_F >=4 )
        {
        // failsafe,       
        // test
        
        RX_Fail=1;
               
         
        }
timer++;
if (timer>=50) {timer=0; timer1=1;}

*/


}

// SPI functions
#include <spi.h>



void SET_RF_Channel(unsigned char a)
{
CSN=0;
spi(0x25);
spi(a);   //  spi(0x02);  //  2- 
CSN=1;
CSN=1;
}


void CRC_1Byte( void ) // POWER_DOWN  RX     0
{
CSN=0;
spi(0x20);
spi(0x09);  //  
CSN=1;
}

void CRC_2Byte( void )  // POWER_DOWN  RX     0
{
CSN=0;
spi(0x20);
spi(0x0D);  //  
CSN=1;
}

void Reset_IRQ( void )  // All
{
CSN=0;
spi(0x27);
spi(0x7E);  //  spi(0x70); spi(0x40);
CSN=1;
}


void init_nRF( void )
{

//  bit PRIM_RX=1 , enable CRC , IRQ-RX_DR
        CSN=0;
        spi(0x20);
        spi(0x3F);
        //spi(0x3D);    
        CSN=1;
        
                //  EN_RXADDR enable all
        CSN=0;
        spi(0x22);
        spi(0x3F);
        CSN=1;
        
                //  EN_AA enable all
        CSN=0;
        spi(0x21);
        spi(0x3F);
        CSN=1;
                  //   0x31
        
                //  RX_PW_P0  = 32
        CSN=0;
        spi(0x31);
        spi(0x20);
        //spi(0x15);   //  21 bytes
        CSN=1;
        
        /*        
                //  RX_PW_P1  = 32
        CSN=0;
        spi(0x32);
        spi(0x20);
        CSN=1;
        
                //  RX_PW_P2  = 32
        CSN=0;
        spi(0x33);
        spi(0x20);
        CSN=1;
        
                //  RX_PW_P3  = 32
        CSN=0;
        spi(0x34);
        spi(0x20);
        CSN=1;
        
                //  RX_PW_P4  = 32
        CSN=0;
        spi(0x35);
        spi(0x20);
        CSN=1;
        
                //  RX_PW_P5  = 32
        CSN=0;
        spi(0x36);
        spi(0x20);
        CSN=1;
        
         */
        
        
        
        

        //  SET TX_ADDR    5 byte lengh
        CSN=0;
        spi(0x30);
        spi(0xE7);
        spi(0xE7);
        spi(0xE7);
        spi(0xE7);
        spi(0xE7);
        CSN=1;
        
        
        
        //  SET RX_ADDR    5 byte lengh      
        CSN=0;
        spi(0x2A);
        spi(0xE7);
        spi(0xE7);
        spi(0xE7);
        spi(0xE7);
        spi(0xE7);
        CSN=1;
        
        
        //  Enable auto ackn.
        CSN=0;
        spi(0x22);
        spi(0x3F);
        CSN=1;
        
        
        //  Setup Retr
        CSN=0;
        spi(0x24);
        spi(0x33);  //  Wait 1 ms before retransmit  ,  try 3 retransmit
        CSN=1;
        
        
        //  SET RF Channel
        //SET_RF_Channel(F1);
        SET_RF_Channel(2);
        /*
        CSN=0;
        spi(0x25);
        spi(channel);   //  spi(0x02);  //  2- 
        CSN=1;
        CSN=1;
        */
        
        
        //  SET  RF Speed and Power
        CSN=0;
        spi(0x26);
        //spi(0x0E);  //  2Mbit/s  0 dBm
        spi(0x26);  //  256 kbit/s  0 dBm
        CSN=1;
        
        
        
}


void init2_nRF( void ) //  !!!!!
{

//  bit PRIM_RX=1 , enable CRC2 , IRQ-RX_DR  Power Up
        CSN=0;
        spi(0x20);
        //spi(9);  //  
        spi(0x3F);    //
        CSN=1;
        //CSN=1;
        
                //  EN_AA disable all
        CSN=0;
        spi(0x21);
        spi(0x00);
        CSN=1;
        //CSN=1;          //   0x31 
        
                //  EN_RXADDR enable 0 
        CSN=0;
        spi(0x22);
        spi(0x01);
        CSN=1;
        //CSN=1;
        
        //  Addres width 5 bytes
        CSN=0;
        spi(0x23);
        spi(0x03);
        CSN=1;
        //CSN=1;
        
        //  SET RF Channel
        SET_RF_Channel(F1);
        
        //  SET  RF Speed and Power
        CSN=0;
        spi(0x26);
        //spi(0x0E);  //  2Mbit/s  0 dBm
        spi(0x26);  //  256 kbit/s  0 dBm
        CSN=1;
        
        //  SET RX_ADDR    5 byte lengh      
        CSN=0;
        spi(0x2A);
        spi(0xE7);
        spi(0xE7);
        spi(0xE7);
        spi(0xE7);
        spi(0xE7);
        CSN=1;
        
        //  SET TX_ADDR    5 byte lengh
        CSN=0;
        spi(0x30);
        spi(0xE7);
        spi(0xE7);
        spi(0xE7);
        spi(0xE7);
        spi(0xE7);
        CSN=1;
        
                //  RX_PW_P0  = 32
        CSN=0;
        spi(0x31);
        spi(0x20);
        CSN=1;
        
       
 
        
}




void ReadBuffer(void)
{
    
CSN=0;
spi(0x61);   //     
for (i=0;i<32;i++) data[i]=spi(0);
CSN=1;      
                  
                  
d1=data[0];  // 21     //    256 
d2=data[10];
d3=data[20];
d4=data[30];
d5=data[31]; //  52

}

void ClearBuffer(void)
{
for (i=0;i<32;i++) data[i]=0;
}


void PrintData(void)
{

LCD_setxy(0,0);
sprintf(tmp,"%u ", data[0] );
LCD_wrs(tmp, 1); 
LCD_setxy(0,10);
sprintf(tmp,"%u ", data[1] );
LCD_wrs(tmp, 1); 
LCD_setxy(0,20);
sprintf(tmp,"%u ", data[2] );
LCD_wrs(tmp, 1);
LCD_setxy(0,30);
sprintf(tmp,"%u ", data[3] );
LCD_wrs(tmp, 1);
LCD_setxy(0,40);
sprintf(tmp,"%u ", data[4] );   
LCD_wrs(tmp, 1);
                    
LCD_refresh();
 
}


void PrintData1(void)     //  unsigned int Kanal[7], K, KK ;   //   
{

if (RX_Fail==1)
        {
        LCD_setxy(40,0);
        sprintf(tmp,"RX Fail" );
        LCD_wrs(tmp, 1);
        //LCD_refresh ();
        }
else
        {
        LCD_setxy(40,0);
        sprintf(tmp,"RX OK  " );
        LCD_wrs(tmp, 1);
        //LCD_refresh ();
        }

LCD_setxy(0,0);
sprintf(tmp,"%u ", F );
LCD_wrs(tmp, 1);
 
LCD_setxy(0,10);
sprintf(tmp,"%u ", Kanal[3] );
LCD_wrs(tmp, 1);
 
LCD_setxy(0,20);
sprintf(tmp,"%u ", Kanal[2] );
LCD_wrs(tmp, 1);

LCD_setxy(0,30);
sprintf(tmp,"%u ", Kanal[0] );
LCD_wrs(tmp, 1);
              
LCD_setxy(0,40);
sprintf(tmp,"%u ", Kanal[6] );   
LCD_wrs(tmp, 1);
                    
if (timer1)  { LCD_refresh(); timer1=0; }  //  1 s
LCD_clear(); 
}





// Declare your global variables here

void main(void)
{
// Declare your local variables here

// Input/Output Ports initialization        out pb 5 3 2 1   in  4
// Port B initialization
// Func7=In Func6=In Func5=Out Func4=In Func3=Out Func2=Out Func1=Out Func0=In 
// State7=P State6=P State5=0 State4=P State3=0 State2=0 State1=0 State0=P 
//PORTB=0xD1;
//DDRB=0x2E;
// Func7=In Func6=In Func5=Out Func4=In Func3=Out Func2=Out Func1=Out Func0=In 
// State7=P State6=P State5=0 State4=P State3=0 State2=0 State1=0 State0=P 
PORTB=0xD1;
DDRB=0x2E;


// Port C initialization
// Func6=In Func5=In Func4=In Func3=In Func2=In Func1=In Func0=In 
// State6=P State5=P State4=P State3=P State2=P State1=P State0=P 
PORTC=0x7F;
DDRC=0x00;

// Port D initialization
// Func7=In Func6=In Func5=In Func4=In Func3=Out Func2=Out Func1=Out Func0=Out 
// State7=P State6=P State5=P State4=P State3=0 State2=0 State1=0 State0=0 
PORTD=0xF0;
DDRD=0x0F;

// Timer/Counter 0 initialization
// Clock source: System Clock
// Clock value: Timer 0 Stopped
TCCR0=0x00;
TCNT0=0x00;

// Timer/Counter 1 initialization
// Clock source: System Clock
// Clock value: Timer1 Stopped
// Mode: Normal top=0xFFFF
// OC1A output: Discon.
// OC1B output: Discon.
// Noise Canceler: Off
// Input Capture on Falling Edge
// Timer1 Overflow Interrupt: On
// Input Capture Interrupt: Off
// Compare A Match Interrupt: Off
// Compare B Match Interrupt: Off
TCCR1A=0x00;
TCCR1B=0x00;
TCNT1H=0x00;
TCNT1L=0x00;
ICR1H=0x00;
ICR1L=0x00;
OCR1AH=0x00;
OCR1AL=0x00;
OCR1BH=0x00;
OCR1BL=0x00;

// Timer/Counter 2 initialization
// Clock source: System Clock
// Clock value: Timer2 Stopped
// Mode: Normal top=0xFF
// OC2 output: Disconnected
ASSR=0x00;
TCCR2=0x00;
TCNT2=0x00;
OCR2=0x00;

// External Interrupt(s) initialization
// INT0: Off
// INT1: Off
MCUCR=0x00;

// Timer(s)/Counter(s) Interrupt(s) initialization
TIMSK=0x04;

// USART initialization
// USART disabled
UCSRB=0x00;

// Analog Comparator initialization
// Analog Comparator: Off
// Analog Comparator Input Capture by Timer/Counter 1: Off
ACSR=0x80;
SFIOR=0x00;

// ADC initialization
// ADC disabled
ADCSRA=0x00;

// SPI initialization
// SPI Type: Master
// SPI Clock Rate: 2000,000 kHz
// SPI Clock Phase: Cycle Start
// SPI Clock Polarity: Low
// SPI Data Order: MSB First
SPCR=0x50;
SPSR=0x00;

// TWI initialization
// TWI disabled
TWCR=0x00;

// Global enable interrupts
#asm("sei")


CE=0;
LCD_init();
LCD_clear_all ();
delay_ms(200);

count_F=0;

RX_Fail=0;

F1=2;
//channel=2;
channel=F1;
init_nRF();


d1=0;
d2=0;
d3=0;

while (1)
      {
      // Place your code here
      
      
      //   Start active RX mode
        
      
        
             
        //  SET POWER UP //    !!!
        CSN=0;
        spi(0x20);
        spi(0x0B);  //  
        CSN=1;
        //CSN=1;
        
        
        
        CE=1;     //  Start RX
        delay_us(180);
        
        //LCD_clear ();
        
      //TCNT1=43535;   // 65535 - 20000 = 45535
      //          SFIOR=1; //    
      //          TCCR1B=2; // 1 uS 
      
      RX_OK=0;
      RX_OK1=0;
      
      LCD_setxy(40,0);
              sprintf(tmp,"Start" );
              LCD_wrs(tmp, 1);
              LCD_refresh ();
              delay_ms(500);
              LCD_clear ();
              LCD_refresh ();
              delay_ms(500);
              
              n=0;
              //SFIOR=1; //     
              //Reset_IRQ();
              //TCCR1B=0x02;  // 1 us
            
      
        /*
            while (1)
              {
              while (IRQ) { TCNT1=0;}   //  n
              Reset_IRQ();
              //while (IRQ)  ;
              n=TCNT1;
              TCCR1B=0x00;
              
              LCD_setxy(40,10);
                    sprintf(tmp,"T=%u us", n );
                    LCD_wrs(tmp, 1);
                    LCD_refresh ();
                    delay_ms(2000);

              }
          */
 

             while (1)
              {
              ReadBuffer();            //   
              PrintData();
              
              
              
                    LCD_refresh ();
                    delay_ms(300);
                    LCD_clear ();
              
                   
                    
                    
              }


       
            while (1)
              {
              
              
              if (!IRQ)
                {
                //ReadBuffer();
                //Reset_IRQ(); 
                //PrintData();
                /*
                CSN=0;
                spi(0xE2);  //  FLUSH_RX
                CSN=1;       
                */
                
                
                //Reset_IRQ(); 
                delay_us(10); 
                //
                if (!IRQ)
                    {
                    LCD_setxy(40,10);
                    sprintf(tmp,"IRQ" );
                    LCD_wrs(tmp, 1);
                    LCD_refresh ();
                    delay_ms(2000);
                    LCD_clear ();
                    }
                else
                    {
                    LCD_setxy(40,10);
                    sprintf(tmp,"Not IRQ" );
                    LCD_wrs(tmp, 1);
                    LCD_refresh ();
                    delay_ms(2000);
                    LCD_clear ();
                    }
                    
                    
                }
              else
                    {
                    LCD_setxy(40,20);
                    sprintf(tmp,"Not IRQ 2" );
                    LCD_wrs(tmp, 1);
                    LCD_refresh ();
                    delay_ms(2000);
                    LCD_clear ();
                    }
                    
                    
                    
              
                    LCD_refresh ();
                    delay_ms(300);
                    LCD_clear ();      
                    
                    
                    
                    
                    
                    
              }      
      
            
      
      
            while (1)
              {
                  if (IRQ) { delay_ms(5); }
                  else  { ReadBuffer(); Reset_IRQ(); PrintData(); ClearBuffer();   //   if (!IRQ)    
                            LCD_setxy(40,10);
                            sprintf(tmp,"IRQ" );
                  
                        }
      
              LCD_refresh ();
              delay_ms(500);
              LCD_clear ();
              }
              
              
              
              
              
            while (1)
              {
              if (!IRQ)
                {
                CSN=0;
                spi(0x61);   //     
                for (i=0;i<32;i++) data[i]=spi(0);
                CSN=1;  
                Reset_IRQ();
                
                LCD_setxy(40,10);
              sprintf(tmp,"IRQ" );
              LCD_wrs(tmp, 1);
              LCD_refresh ();
              //delay_ms(1000);
                
                }
              
                K_H=data[14];
                K_L=data[15];
                Kanal[4]=(K_H<<8) + K_L;
              
              
                LCD_setxy(0,10);
                sprintf(tmp,"%u ", Kanal[4] );
                LCD_wrs(tmp, 1);
              
                LCD_refresh ();
              delay_ms(1000);
              LCD_clear ();
              LCD_refresh ();
              delay_ms(1000);
              }
      
      
         
            while (1)
              { 
              //if (!IRQ)  //   
              //  :  10  ,   -   ,   
              //      1  2   Data_0  Data_1,  ,
              //    failsafe,  0,   
              //   
              //          {
                        
                        TCNT1=43535;   // 65535 - 20000 = 45535
                        SFIOR=1; //    
                        //TCCR1B=2; // 1 uS 
                        
                        //   2    
                        //    ,    ,   
                        
                        CSN=0;
                        spi(0x61);   //     
                        for (i=0;i<32;i++) data[i]=spi(0);
                        //for (i=0;i<32;i++) data[i]=i;
                        CSN=1;  
                        Reset_IRQ();
                        if ( data[0]==33&&data[1]==45 )
                            {
                            RX_Fail=0;
                            if (RX_OK1==0)
                                {
                                RX_OK++;
                                if (RX_OK >=20) { RX_OK1=1; F2=data[3]; F3=data[4]; F4=data[5];  }
                                }
                            }
                        //ReadBuffer();
                        
                        // unsigned int Kanal[7], K, KK ;   //   
              //          }
                        K_H=data[6];
                        K_L=data[7];
                        Kanal[0]=(K_H<<8) + K_L;
                        
                        K_H=data[8];
                        K_L=data[9];
                        Kanal[1]=(K_H<<8) + K_L;
                        
                        K_H=data[10];
                        K_L=data[11];
                        Kanal[2]=(K_H<<8) + K_L;
                        
                        K_H=data[12];
                        K_L=data[13];
                        Kanal[3]=(K_H<<8) + K_L;
                        
                        K_H=data[14];
                        K_L=data[15];
                        Kanal[4]=(K_H<<8) + K_L;
                        
                        K_H=data[16];
                        K_L=data[17];
                        Kanal[5]=(K_H<<8) + K_L;
                        
                        K_H=data[18];
                        K_L=data[19];
                        Kanal[6]=(K_H<<8) + K_L; 
                        
                        PrintData(); 
                        
                          
              
                PrintData1();
              
              
              
                            
              
              
              
              //while (!(status&0b01000000))
              //{
              //   CSN=0;
              //   status=spi(0);
              //   CSN=1;
              //}
                 //ReadBuffer();
                 
                 
                 //Reset_IRQ(); 
                 /*
                  LCD_setxy(30,20);
                  sprintf(tmp,"Status = %u ", status );   
                  LCD_wrs(tmp, 1);
                  */
                  
                  //ReadBuffer(); 
                  //PrintData();
                  
                  
                  /*
                  LCD_setxy(22,10);
                  if (status&0b01000000)  { sprintf(tmp,"RX Data Ready", status );  LCD_wrs(tmp, 1);  
                  ReadBuffer();  Reset_IRQ();
                  
                  } // 
                  
                  else                    { sprintf(tmp,"             ", status );  LCD_wrs(tmp, 1);  }
                  
                  LCD_setxy(22,20);
                  if (status&0b00100000)  { sprintf(tmp,"TX Data Sent", status );  LCD_wrs(tmp, 1);  }
                  else                    { sprintf(tmp,"            ", status );  LCD_wrs(tmp, 1);  }
                  LCD_setxy(22,30);
                  if (status&0b00010000)  { sprintf(tmp,"Max ReTransmit", status );  LCD_wrs(tmp, 1);  }
                  else                    { sprintf(tmp,"              ", status );  LCD_wrs(tmp, 1);  }
                  LCD_setxy(22,40);
                  if (status&0b00001110)  { sprintf(tmp,"RX FIFO Empty", status );  LCD_wrs(tmp, 1);  }
                  else                    { sprintf(tmp,"             ", status );  LCD_wrs(tmp, 1);  }
                  LCD_setxy(22,50);
                  if (status&0b00000001)  { sprintf(tmp,"TX FIFO Full", status );  LCD_wrs(tmp, 1);  }
                  else                    { sprintf(tmp,"            ", status );  LCD_wrs(tmp, 1);  }

                  LCD_setxy(0,50);
                  if (!IRQ)  { sprintf(tmp,"IRQ", status );  LCD_wrs(tmp, 1);  }    //  Reset_IRQ();
                  else                    { sprintf(tmp,"   ", status );  LCD_wrs(tmp, 1);  }
                  
                  */
                  
                  
                  
                  
                  /*
                  
                  CSN=0;            //     
                  spi(9);
                  status=spi(0);
                  CSN=1;
              
                  LCD_setxy(22,0);
                  sprintf(tmp,"RF = %u ", status );  //      
                  LCD_wrs(tmp, 1);     
                  
                  */
                  
                  
                  
              

              
              
              //      
              //PrintData(); 
              
              
              /*
              LCD_setxy(0,0);   //  PrintData()
              if (d1>0)
              { sprintf(tmp,"%u ", d1 );
              LCD_wrs(tmp, 1); }
              LCD_setxy(0,10);
              if (d2>0) 
              { sprintf(tmp,"%u ", d2 );
              LCD_wrs(tmp, 1); }
              LCD_setxy(0,20);
              if (d3>0) 
              { sprintf(tmp,"%u ", d3 );
              LCD_wrs(tmp, 1);}
              LCD_setxy(0,30);
              
              if (d4>0) 
              { sprintf(tmp,"%u ", d4 );
              LCD_wrs(tmp, 1);}
              
              LCD_setxy(0,40);
              if (d5>0) 
              { sprintf(tmp,"%u ", d5 );   
              LCD_wrs(tmp, 1);}
                    
              LCD_refresh();    
              */ 
              /*      
                    for (i=0;i<10;i++)
                        {
                        while(IRQ) delay_ms(100); 
                        if (i==9) break;   
                        }
               */         //////////
              delay_ms(800);   ////////
              //Reset_IRQ();
               
              LCD_refresh();
              LCD_clear ();     // 
              //       ...
              /*     
              for ( k=0;k<128;k++ )
                {
                 n=0; 
                 status=0; 
                 SET_RF_Channel(k);
                 while ( n<10000 )
                    {
                      CSN=0;            //     
                     spi(9);
                     l=spi(0); //   l=spi(0);
                     CSN=1;
                      n=n+1;
                      if (l) status=1;
                      //delay_us(400);

                    }
                    
                    
                LCD_clear ();
                LCD_setxy(22,0);
                sprintf(tmp,"Channel = %u ", k );  //  
                LCD_wrs(tmp, 1);
                    
                LCD_setxy(22,10);
                sprintf(tmp,"RF = %u ", status );  //  
                LCD_wrs(tmp, 1);
                    
                LCD_refresh(); 
                status=0;
                }
                */    

              }
      
      
      
      
      }
}
